<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "campaign_email".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CampaignEmail".
 *
 * Columns in table "campaign_email" available as properties of the model,
 * followed by relations of table "campaign_email" available as properties of the model.
 *
 * @property integer $id
 * @property integer $campaign_id
 * @property integer $account_id
 * @property string $to
 * @property string $subject
 * @property string $content
 * @property string $content_plain
 * @property string $date_created
 * @property string $date_sent
 * @property integer $processed
 *
 * @property Account $account
 * @property Campaign $campaign
 * @property CampaignEmailLink[] $campaignEmailLinks
 */
abstract class BaseCampaignEmail extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'campaign_email';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CampaignEmail|CampaignEmails', $n);
    }

    public static function representingColumn()
    {
        return 'to';
    }

    public function rules()
    {
        return array(
            array('campaign_id, to, subject, content, content_plain, date_created', 'required'),
            array('campaign_id, account_id, processed', 'numerical', 'integerOnly' => true),
            array('to, subject', 'length', 'max' => 255),
            array('date_sent', 'safe'),
            array('account_id, date_sent, processed', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, campaign_id, account_id, to, subject, content, content_plain, date_created, date_sent, processed', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'campaign' => array(self::BELONGS_TO, 'Campaign', 'campaign_id'),
            'campaignEmailLinks' => array(self::HAS_MANY, 'CampaignEmailLink', 'campaign_email_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'campaign_id' => null,
            'account_id' => null,
            'to' => Yii::t('app', 'To'),
            'subject' => Yii::t('app', 'Subject'),
            'content' => Yii::t('app', 'Content'),
            'content_plain' => Yii::t('app', 'Content Plain'),
            'date_created' => Yii::t('app', 'Date Created'),
            'date_sent' => Yii::t('app', 'Date Sent'),
            'processed' => Yii::t('app', 'Processed'),
            'account' => null,
            'campaign' => null,
            'campaignEmailLinks' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('campaign_id', $this->campaign_id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('to', $this->to, true);
        $criteria->compare('subject', $this->subject, true);
        $criteria->compare('content', $this->content, true);
        $criteria->compare('content_plain', $this->content_plain, true);
        $criteria->compare('date_created', $this->date_created, true);
        $criteria->compare('date_sent', $this->date_sent, true);
        $criteria->compare('processed', $this->processed);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
